Subject: Re: Strangeness in ehea network driver's shutdown

From: Jakub Kicinski <[email-masked]>
Date: Mon, 3 Oct 2022 09:36:06 -0700

On Sat, 1 Oct 2022 16:31:31 +0200 Uwe Kleine-König wrote:
> Hello,
> 
> while doing some cleanup I stumbled over a problem in the ehea network
> driver.
> 
> In the driver's probe function (ehea_probe_adapter() via
> ehea_register_memory_hooks()) a reboot notifier is registered. When this
> notifier is triggered (ehea_reboot_notifier()) it unregisters the
> driver. I'm unsure what is the order of the actions triggered by that.
> Maybe the driver is unregistered twice if there are two bound devices?
> Or the reboot notifier is called under a lock and unregistering the
> driver (and so the devices) tries to unregister the notifier that is
> currently locked and so results in a deadlock? Maybe Greg or Rafael can
> tell about the details here?
> 
> Whatever the effect is, it's strange. It makes me wonder why it's
> necessary to free all the resources of the driver on reboot?! I don't
> know anything about the specifics of the affected machines, but I guess
> doing just the necessary stuff on reboot would be easier to understand,
> quicker to execute and doesn't have such strange side effects.
> 
> With my lack of knowledge about the machine, the best I can do is report
> my findings. So don't expect a patch or testing from my side.

Last meaningful commit to this driver FWIW:

commit 29ab5a3b94c87382da06db88e96119911d557293
Author: Guilherme G. Piccoli <[email-masked]>
Date:   Thu Nov 3 08:16:20 2016 -0200

Also that's the last time we heard from Douglas AFAICT..